/***
 * AOKell Comanche web server
 * Copyright (C) 2005 INRIA, France Telecom
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Lionel.Seinturier@lifl.fr
 *
 * Author: Lionel Seinturier
 */

package comanchemain;

import aokell.lib.membrane.primitive.PrimitiveType;

/**
 * @author Lionel Seinturier <Lionel.Seinturier@lifl.fr>
 */
public aspect Conf {
    
    // Not all classes in comanche.* are Fractal components 
    // declare parents: comanche.* implements PrimitiveType;
    
    declare parents: comanche.BasicLogger implements PrimitiveType;
    declare parents: comanche.ErrorRequestHandler implements PrimitiveType;
    declare parents: comanche.FileRequestHandler implements PrimitiveType;
    declare parents: comanche.MultiThreadScheduler implements PrimitiveType;
    declare parents: comanche.RequestAnalyzer implements PrimitiveType;
    declare parents: comanche.RequestDispatcher implements PrimitiveType;
    declare parents: comanche.RequestReceiver implements PrimitiveType;
    declare parents: comanche.SequentialScheduler implements PrimitiveType;
}
