/***
 * Fractal Hello World Example
 * Copyright (C) 2001-2002 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Eric.Bruneton@rd.francetelecom.com
 * Contact: Lionel.Seinturier@lifl.fr
 *
 * Author: Eric Bruneton
 * Author: Lionel Seinturier
 */

package cstemplateadl;

import java.util.HashMap;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.adl.FactoryFactory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;

import aokell.AOKell;


public class Main {

    public static void main(String[] args) throws Exception {
        
        System.setProperty("fractal.provider",AOKell.class.getName());
        
        // ----------------------------------------------------------        
        // Load the ADL definition
        // ----------------------------------------------------------        
        Factory factory = 
            FactoryFactory.getFactory(FactoryFactory.FRACTAL_BACKEND);
        Component rootTemplate = (Component) factory.newComponent(
                "cstemplateadl.impl.ClientServerImpl",new HashMap());
        
        // ----------------------------------------------------------
        // Instantiate the template
        // ----------------------------------------------------------
        Component root = Fractal.getFactory(rootTemplate).newFcInstance();
        
        // ----------------------------------------------------------
        // Start the component
        // ----------------------------------------------------------
        Fractal.getLifeCycleController(root).startFc();
        
        // ----------------------------------------------------------
        // Call the entry point of the application
        // ----------------------------------------------------------
        ((Runnable)root.getFcInterface("m")).run();
    }
}
